package com.rthoni.stssaguenay.dbo;

import com.luticate.utils.dbo.LuDbo;

import org.json.JSONArray;
import org.json.JSONException;
import org.json.JSONObject;

import java.util.HashMap;
import java.util.List;
import java.util.Vector;

/**
 * Created by robin on 10/1/16.
 */

public class FavouriteStopDbo extends LuDbo {

    protected StopsDbo _stop;

    protected List<RoutesDbo> _routes;

    @Override
    public void fromJson(JSONObject json) throws JSONException {
        _stop = new StopsDbo();
        _stop.fromJson(json.getJSONObject("stop"));
        _routes = new Vector<>();
        JSONArray routes = json.getJSONArray("routes");
        for (int i = 0; i < routes.length(); ++i) {
            RoutesDbo route = new RoutesDbo();
            route.fromJson(routes.getJSONObject(i));
            _routes.add(route);
        }
    }

    @Override
    public HashMap<String, Object> toArray() {
        HashMap<String, Object> map = new HashMap<>();
        map.put("stop", _stop.toArray());
        List<Object> routes = new Vector<>();
        for (RoutesDbo route : _routes) {
            routes.add(route.toArray());
        }
        map.put("routes", routes);
        return map;
    }

    public StopsDbo getStop() {
        return _stop;
    }

    public void setStop(StopsDbo stop) {
        _stop = stop;
    }

    public List<RoutesDbo> getRoutes() {
        return _routes;
    }

    public void setRoutes(List<RoutesDbo> routes) {
        _routes = routes;
    }
}
