package com.rthoni.stssaguenay.ui.activities;

import android.app.Activity;
import android.content.Intent;
import android.os.Bundle;
import android.support.v7.app.AppCompatActivity;

import com.google.android.gms.ads.AdRequest;
import com.google.android.gms.ads.AdView;
import com.google.android.gms.ads.MobileAds;
import com.luticate.utils.business.LuPromise;
import com.rthoni.stssaguenay.R;
import com.rthoni.stssaguenay.dbo.FavouriteStopDbo;
import com.rthoni.stssaguenay.dbo.RoutesDbo;
import com.rthoni.stssaguenay.dbo.StopsDbo;
import com.rthoni.stssaguenay.ui.fragments.StopPickerFragment;
import com.rthoni.stssaguenay.ui.fragments.StopRoutesPickerFragment;

import java.util.List;

public class StopPickerActivity extends AppCompatActivity {

    public static String STOP_EXTRA_NAME = "STOP_EXTRA";

    private StopPickerFragment _stopPickerFragment;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_stop_picker);

        MobileAds.initialize(getApplicationContext(), getString(R.string.ad_init));
        AdView mAdView = (AdView) findViewById(R.id.adView);
        AdRequest adRequest = new AdRequest.Builder().build();
        mAdView.loadAd(adRequest);

        if (getSupportActionBar() != null) {
            getSupportActionBar().setDisplayHomeAsUpEnabled(true);
        }
        goToStops();
    }

    @Override
    public boolean onSupportNavigateUp() {
        if (getSupportFragmentManager().getBackStackEntryCount() == 0) {
            return super.onSupportNavigateUp();
        }
        getSupportFragmentManager().popBackStack();
        return true;
    }

    public void goToStops()
    {
        StopPickerFragment f = new StopPickerFragment();
        f.setOnStopSelectedConsumer(new LuPromise.LuConsumer<StopsDbo>() {
            @Override
            public void execute(StopsDbo data) {
                goToRoutes(data);
            }
        });
        getSupportFragmentManager()
                .beginTransaction()
                .replace(R.id.container, f)
                .commit();
    }

    public void goToRoutes(final StopsDbo stopDbo)
    {
        StopRoutesPickerFragment f = new StopRoutesPickerFragment();
        f.setStopsDbo(stopDbo);
        f.setOnRoutesSelected(new LuPromise.LuConsumer<FavouriteStopDbo>() {
            @Override
            public void execute(FavouriteStopDbo data) {
                saveStop(data);
            }
        });
        getSupportFragmentManager()
                .beginTransaction()
                .replace(R.id.container, f)
                .addToBackStack("StopRoutesPickerFragment")
                .commit();
    }

    public void saveStop(FavouriteStopDbo favouriteStopDbo)
    {
        Intent result = new Intent();
        result.putExtra(STOP_EXTRA_NAME, favouriteStopDbo.toString());
        setResult(Activity.RESULT_OK, result);
        finish();
    }
}
